﻿#pragma warning( disable : 4996 )
#include "CWindow.h"
#include "CDIPro81.h"
#include <stdio.h>

#define DEBUGMODE
#include "debug.h"


// グローバル変数定義
CWindow		win;					// ウインドウ
CDIPro81	di;						// DirectInput


// TextOutの拡張版
void TextOutEx( HDC hdc,int x,int y,char *str,... )
{
	char s[4096];
	va_list ap;
	va_start( ap,str );
	vsprintf( s,str,ap );
	va_end( ap );
	TextOutA( hdc,x,y,s,(int)strlen(s) );
}

// メインルーチン
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdParam, int nCmdShow)
{
	INITDEBUG();
	CLEARDEBUG();

	// ウインドウ
	if( !win.Create(hInstance,L"CDIProSample") )
		return -1;

	// DirectInput
	if( !di.Create(win.hWnd,win.hInstance) )
		return -1;

	// キーボードデバイスを作成
	di.CreateKeyboard();

	// マウスデバイスを作成
	di.CreateMouse();

	// ジョイスティックデバイスを作成
	di.CreateJoystick();

	MSG msg;
	while(1) {
		if( PeekMessage(&msg,NULL,0,0,PM_REMOVE) ) {
			if( msg.message==WM_QUIT ) {
				DEBUG( "WM_QUIT\n" );
				break;
			}
			TranslateMessage(&msg);
        	DispatchMessage(&msg);
		}

		////////////////////////////////////////////////////////
		// 入力
		////////////////////////////////////////////////////////

		// キーボードを取得
		BYTE key[256];
		di.GetKeyboard( key );

		// ESCAPEなら終了
		if( key[DIK_ESCAPE]&0x80 )
			break;

		// マウスを取得
		DIMOUSESTATE mouse;
		di.GetMouse( &mouse );

		// ジョイスティックを取得(1つ目のみ)
		DIJOYSTATE2 joy;
		di.GetJoystick( &joy,0 );



		////////////////////////////////////////////////////////
		// 描画
		////////////////////////////////////////////////////////
		HDC hdc = GetDC( win.hWnd );
		if( hdc ) {

			// キーボードビット表示
			TextOutEx( hdc,0,0,"--------- キーボードビット ---------" );
			int i;
			for( i=0;i<16;i++ ) {
				TextOutEx( hdc,(i%16)*20+20,20,"%02X",i );
				TextOutEx( hdc,0,i*20+40,"%02X",i*16 );
			}
			for( i=0;i<256;i++ ) {
				if( key[i]&0x80 ) {
					TextOutEx( hdc,(i%16)*20+20,(i/16)*20+40,"●" );
				} else {
					TextOutEx( hdc,(i%16)*20+20,(i/16)*20+40,"○" );
				}
			}

			// マウス表示
			TextOutEx( hdc,400,0,"--- マウス(相対モード) ---" );
			TextOutEx( hdc,400,20,"X = %d      ",mouse.lX );
			TextOutEx( hdc,480,20,"Y = %d      ",mouse.lY );
			TextOutEx( hdc,560,20,"Z = %d      ",mouse.lZ );

			TextOutEx( hdc,400,40,"ボタン" );
			for( i=0;i<4;i++ ) {
				if( mouse.rgbButtons[i]&0x80 ) {
					TextOutEx( hdc,460+i*20,40,"●" );
				} else {
					TextOutEx( hdc,460+i*20,40,"○" );
				}
			}

			// ジョイスティック表示
			TextOutEx( hdc,400,80,"--- ジョイスティック ---" );
			TextOutEx( hdc,400,100,"接続数 = %d ",di.GetJoyNum() );
			TextOutEx( hdc,400,140,"●1つ目のジョイスティック" );
			TextOutEx( hdc,400,160,"X = %d    ",joy.lX );
			TextOutEx( hdc,480,160,"Y = %d    ",joy.lY );
			TextOutEx( hdc,560,160,"Z = %d    ",joy.lZ );
			TextOutEx( hdc,400,180,"RX = %d    ",joy.lRx );
			TextOutEx( hdc,480,180,"RY = %d    ",joy.lRy );
			TextOutEx( hdc,560,180,"RZ = %d    ",joy.lRz );
			TextOutEx( hdc,400,200,"Slider0 = %d    ",joy.rglSlider[0] );
			TextOutEx( hdc,520,200,"Slider1 = %d    ",joy.rglSlider[1] );
			TextOutEx( hdc,400,220,"POV0 = %d    ",joy.rgdwPOV[0] );
			TextOutEx( hdc,520,220,"POV1 = %d    ",joy.rgdwPOV[1] );
			TextOutEx( hdc,400,240,"POV2 = %d    ",joy.rgdwPOV[2] );
			TextOutEx( hdc,520,240,"POV3 = %d    ",joy.rgdwPOV[3] );
			TextOutEx( hdc,400,260,"ボタンビット" );
			for( i=0;i<128;i++ ) {
				if( joy.rgbButtons[i]&0x80 ) {
					TextOutEx( hdc,(i%16)*8+420,(i/16)*20+280,"1" );
				} else {
					TextOutEx( hdc,(i%16)*8+420,(i/16)*20+280,"0" );
				}
			}

			ReleaseDC( win.hWnd,hdc );
		}

		Sleep(15);
	}

	di.Delete();
	win.Delete();

	return 0;
}
